class DiamondPrinter {
    fun printToList(inpChar: Char): List<String> {
        val returnList: MutableList<String> = mutableListOf()
        val charList = CharRange('A', inpChar).toList()
        val length = charList.size
        // TODO: Make specific branch for 'A'
        for (i in 0..length - 1){
            val testChar: Char = charList[i]
            val totalLength: Int = (length * 2) - 1
            val builder = StringBuilder()
            if (testChar == 'A'){
                val beforeSpaces: Int = length - 1

                builder.append(CharArray(beforeSpaces, {' '}))
                        .append(testChar)
                        .append(CharArray(beforeSpaces, {' '}))
            } else {
                val beforeSpaces: Int = length - i - 1
                val middleSpaces: Int = totalLength - (beforeSpaces * 2) - 2

                builder.append(CharArray(beforeSpaces, {' '}))
                        .append(testChar)
                        .append(CharArray(middleSpaces, {' '}))
                        .append(testChar)
                        .append(CharArray(beforeSpaces, {' '}))
            }
            returnList.add(index = (returnList.size/2), element = String(builder))
            returnList.add(index = (returnList.size/2), element = String(builder))
        }
        returnList.removeAt(returnList.size/2)
        return returnList
    }
}